///  discretization from a continuos transfer function.
//      ( not from state space )
z=%z;
s=%s
ts = 2;                // sample time
fns=syslin('c',1/(s+0.2)/(s+0.4));  //target function
disp('continuos system')
disp(fns)
fn=syslin('c',fns/s);  //s part of target function*(1-1/z)/s
fs0=0.01*1/ts/2;       // start freq.
fsn=0.99*1/ts/2;       // stop freq.
ff = fs0+(fsn-fs0)*(0:20)/20;
i0=(-20:20)/ts

fd=[]
for i=1:size(ff,'*')
  fh = ff(1,i)+i0
  a0 = repfreq(fn,fh)

  zf = exp(%i*ff(1,i)*2*%pi*ts);
  qf = horner(1-1/z,zf);
  fd = [fd;qf*sum(a0)/ts]
end


at =[ff',abs(fd),imag(log(fd))/%pi*180];  //  prepare data in the file

if MSDOS then unix('del foo');
else unix('rm -f foo'); end
write('foo',at)

px = piir(ts,2,'foo',0.01,1);  // The order of px is 2. Phase error is 0.01

dx=ss2tf(dscr(fns,ts))

clf()

bode([px;dx],0.01,1/ts/2,0.001)

// px is almost same as dx
disp('output from dscr')
disp(dx)

disp('calculated function')
disp(px)
