//  the target function is stable except a predetermined factor
//  but not the minimum phase function
z=%z;
ts = 1;                // sample time
fz=(z+4)*(z-0.2)/(z-1)/(z+0.1);    //target function

disp('target function')
disp(fz)

fs0=0.01*1/ts/2;       // start freq.
fsn=0.99*1/ts/2;       // stop freq.
ff = fs0+(fsn-fs0)*(0:20)/20;
zf = exp(%i*ff'*2*%pi*ts);
qf = horner(fz,zf);
at =[ff',abs(qf),imag(log(qf))/%pi*180];  //  prepare data in the file

if MSDOS then unix('del foo');
else unix('rm -f foo'); end
write('foo',at)

px = piir(ts,-2,'foo',0.001,0,1/(z-1));  // the function has a predetermined factor z-1. 

// px is almost same as fz
disp('result')
disp(px)
