
function aa = log_fir(t0x,forder,freq_filex,g_errx)
  global t0

  t0 = t0x

  aax=log_fir2(forder,freq_filex,[],[],0,g_errx)

  aa = aax

endfunction


function x_err = get_xerr(xerr,fwx)
//
//  error
//
//  if dimension (xerr ) == 1 
//      x_err = xerr*ones(1,n1x)
//  else
//      x_err(1,1) =xerr(1,2)   if xerr(1,1) 
//
 global t0

 n1x = size(fwx,'*')

 [n1,m1] = size(xerr)
 x_err=[]
 if m1 == 1 then 
   x_err = xerr(1,1)*ones(1,n1x)
 else
   fl = xerr(n1,1)    // last freq

   if fl < 1/t0/2 then  // add data till the freq. higher than Nyquist
      xerr= [xerr;1/t0,xerr(n1,2)]
      n1 = n1+1
   end

   x_err = zeros(1,n1x)
   for i=1:n1
      fx = xerr(i,1)*ones(1,n1x)   // get freq
      if i <> 1 then
        fx1 = xerr(i-1,1)*ones(1,n1x)
      else
        fx1 = -1*ones(1,n1x)
      end
      fn = (fwx <= fx) & ( fwx > fx1)  // set T or F
      x_err = x_err + xerr(i,2)*fn
   end
 end

endfunction

if exists('def_fderive') == 0 then
 function dgf = fderiv(fz1)
  dgf=derivat(numer(fz1))./denom(fz1)-numer(fz1).*(derivat(denom(fz1)))./denom(fz1).^2
 endfunction
 def_fderive = 1
end


function [LME,LMI,OBJ] = logfir2(A0)

//
 global logfir_1
 GUP = logfir_1(1)
 GAU = logfir_1(2)
 GLO = logfir_1(3)
 GAL = logfir_1(4)

 PUP  = logfir_1(5)
 PAU  = logfir_1(6)
 PLO  = logfir_1(7)
 PAL  = logfir_1(8)
 c_flag  = logfir_1(9)
 SM0  = logfir_1(10)
 SMF  = logfir_1(11)
 EX   = logfir_1(12)
 BLU   = logfir_1(13)
 w_weight   = logfir_1(14)
 PXL = logfir_1(15)

 C0 = A0(1)
 lamda = A0(2)

 p1 = list()
 gt1 = GUP - GAU*C0
 for i = 1: size(GUP,'*')
   p1(i) = gt1(i,1)
 end

 p2 = list()
 gt2 =  GAL*C0 -GLO
 for i = 1: size(GLO,'*')
   p2(i) = gt2(i,1)
 end

 p3 = list()
 gt3 = PUP - PAU*C0
 for i = 1: size(PUP,'*')
   p3(i) = gt3(i,1)
 end

 p4 = list()
 gt4 = PAL*C0 - PLO
 for i = 1: size(PLO,'*')
   p4(i) = gt4(i,1)
 end

//  |1-S| < lmt -> [ lmt , logG + P*C;(logG + P*C)^*,I]
//  [X,-Y;Y,X] where X = [lmt,real(logG + P*C);real(logG + P*C)^*,I] 
//  Y = [0,imag(logG + P*C);imag(logG + P*C)^*,0]
 p5 = list()
 gt4r = PXL.GAR*C0
 gt4i = PXL.GAI*C0
 for i = 1: size(PXL.LMT,'*')
   X = [PXL.LMT(i,1),gt4r(i,1)+PXL.log_r(i,1);(gt4r(i,1)+PXL.log_r(i,1))',1]
   Y = [0,gt4i(i,1)+PXL.log_i(i,1);-(gt4i(i,1)+PXL.log_i(i,1))',0]

   p5(i) = [X,-Y;Y,X]
 end

 // equation
 e1 = list()
 et1 = EX.E1-(EX.GE1)*C0
 for i= 1:size(EX.E1,'*')
   e1(i) = et1(i,1)
 end

 // limit 


 q1 = list()
 //qt1 = G1- GA1*C0
 qt1 = real(BLU.G1)-BLU.GA1*C0
 for i = 1: size(BLU.G1,'*')
   q1(i) = qt1(i,1)
 end

 
 q2 = list()
 qt2 = BLU.GA2*C0 - real(BLU.G2)
 for i = 1: size(BLU.G2,'*')
   q2(i) = qt2(i,1)
 end

 q3 = list()
 qt3 = real(BLU.P1)- BLU.PA1*C0
 for i = 1: size(BLU.P1,'*')
   q3(i) = qt3(i,1)
 end

 q4 = list()
 qt4 = BLU.PA2*C0 - real(BLU.P2)
 for i = 1: size(BLU.P2,'*')
   q4(i) = qt4(i,1)
 end

 //  smooth function
 s1= list()
 if (c_flag(1,2) == 0) | (c_flag(1,2) ==2) then
   st1 = SM0+SMF*C0
   n1 = size(SM0,'*') 
   S0 = eye(n1+1,n1+1)
   S0(1,1) = lamda
   for i = 1:n1
     S0(1,i+1) = st1(i,1)
     S0(i+1,1) = st1(i,1)
     S0(i+1,i+1) = 1/w_weight(1,i)
   end
   s1(1) = S0
 end

 LMI = list(p1,p2,p3,p4,p5,q1,q2,q3,q4,s1,lamda)

 LME = e1
 OBJ = [lamda]

endfunction



function aa = log_fir2(forder,freq_filex,r_polesx,l_polesx,startix,g_errx,p_errx,log_funx,c_flagx,fweightx,read_fx)

//  main prg
// 
//  get Y= log X = a0 + a1/z
//
//  input
//   forder:    order of fir 
//   freq_file: file in which_
//             freq  gain  phase  upper_gain lower_gain u_phase l_phase
//                  if upper_gain >=  gain, the data is used
//                  if lower_gain <  gain, the data is used
//                  if upper_phase >=  phase, the data is used
//                  if lower_phase <  phase, the data is used
//
//   r_poles:   [p1, k1;p2, k2;..] Y(p1)+log(log_fun) = k1, ...  for equation
//   l_poles:   [p1, ru1,rl1,pu1,pl1,d1,fd1;         
//               p2, ru2,rl2,pu2,pl2,d2,fd2;..]  ...  for inequality around the pole
//                         ru1 > d1*real(Y(p1)+log(log_fun)) > rl1, 
//                         pu1 > d2*imag(Y(p2)+log(log_fun)) > pl1, 
//                         if fd1 == 0 
//                              ru1 > d1*real(Y(p1)) > rl1   ( without lpg_fun )
//   starti:    Y = a0*z^(-starti) + a1*z^(-starti-1)+..
//   g_err:     if <>0 then upper gain = gain*g_err, lower gain = gain/g_err
//   p_err:     if <>0 then upper phase = phase*p_err, lower phase = phase/p_err
//   log_fun:   syslin(dt,) Y = log (log_fun) + log X used for equation & smooth
//   c_flag:    [c1,c2] c1 ==0: use LME, ==1:do not use equation: ==2 
//                      c2 ==0: min(d Y /dw - DY), ==1: min(log F + d Y/dw -DFY),
//                         ==2: fa1+fp1*.. fa1(a)=c,fp1(a)=0
//
//   fweight:   if [f1,x1;f2,x2;,,]  f<f1 -> x1
//   read_f:    =1: read g(w) where |1-S(w)|<g(w)
//  output
//
//
 global t0

 arg_num = argn(2)

 last_arg = 2



 r_poles = []
 if arg_num > last_arg then
   r_poles = r_polesx
 end

 l_poles = []
 if arg_num > last_arg+1 then
   l_poles = l_polesx
 end

 starti = 1
 if arg_num > last_arg+2 then
   starti = startix
 end

 g_err = 0
 if arg_num > last_arg+3 then
   g_err = g_errx
 end

 p_err = 0
 if arg_num > last_arg+4 then
   p_err = p_errx
 end

 log_fun = z/z
 if arg_num > last_arg+5 then 
   log_fun = log_funx
 end


 c_flag = [0,0]
 if arg_num > last_arg+6 then 
   c_flag = c_flagx
 end

 fweight = 1
 if arg_num > last_arg+7 then 
   fweight = fweightx
 end

 read_f = 0
 if arg_num > last_arg+8 then 
   read_f = read_fx
 end

 ufabs=[]
 lfabs=[]
 ufarg=[]
 lfarg=[]
 
 disp(freq_filex)
 fd=mopen(freq_filex,'r')

 dplmt = []

 if g_err == 0 & p_err == 0 then
   if read_f == 0 then
     [freqnum,fw,fabs,farg,ufabs,lfabs,ufarg,lfarg]=mfscanf(-1,fd,"%e %e %e %e %e %e %e")
     dplmt = zeros(fw)
   else
     [freqnum,fw,fabs,farg,ufabs,lfabs,ufarg,lfarg,dplmt]=mfscanf(-1,fd,"%e %e %e %e %e %e %e %e")
   end
 else
   [freqnum,fw,fabs,farg]=mfscanf(-1,fd,"%e %e %e")
   dplmt = zeros(fw)

  //  make gain, phase spec

   gerr = get_xerr(g_err,fw)
   perr = get_xerr(p_err,fw)
   gerr = (ones(gerr)+gerr)'
   perr = perr'
 
   ufabs = fabs.*gerr
   lfabs = fabs./gerr

   for i = 1:size(farg,'*')
     if  perr(i,1) <> 0 then 
       lfarg(i,1) = farg(i,1)-perr(i,1)
       ufarg(i,1) = farg(i,1)+perr(i,1)
     else
       lfarg(i,1) = farg(i,1)+ 0.01
       ufarg(i,1) = farg(i,1)- 0.01 
     end
   end
 end
 mclose(fd)

 farg = farg*%pi/180
 ufarg=ufarg*%pi/180
 lfarg=lfarg*%pi/180

 
 fa1 = 0
 fp1 = 1

 if c_flag(1,2) ==  2 then
   [n1,n2] = size(r_poles)

   rx_p = []    // add conjugate 
   rx_ka = []
   for j = 1:n1
     rx_p = [rx_p;r_poles(j,1)]
     rx_ka = [rx_ka;r_poles(j,2)]
     if imag(r_poles(j,1)) <> 0 then
       rx_p = [rx_p;conj(r_poles(j,1))]
       rx_ka = [rx_ka;conj(r_poles(j,2))]
     end
   end

   n1 = size(rx_p,'*')
   sumkj = 0
   fp1 = real(prod(ones(rx_p)*z-rx_p))/z^size(rx_p,'*')

   
   for j=1:n1
     i1 = 1:n1
     q1 = i1<>j
     i2 = i1(q1)
     px = ones(rx_p(i2,1))-rx_p(i2,1)/rx_p(j,1)
     pxz = ones(rx_p(i2,1))*z-rx_p(i2,1)
     kk = rx_ka(j,1)-log(horner(log_fun,rx_p(j,1)))
     kkj = kk*(rx_p(j,1)/z)^starti*prod(pxz)/z^size(i2,'*')/prod(px)
     sumkj = sumkj+kkj
  end
  fa1 = real(numer(sumkj))/real(denom(sumkj))
 end


 fza = z^(-starti:-1:-(forder+starti))

 fza = fp1*fza

 w0 = exp(%i*2*%pi*t0*fw)

//  set uuper limit/ lower limit, upper phase/ lower phase

 GUP = []
 GAU = []  // GUP(i,1) > GAU(i,:)*C0

 GLO = []
 GAL = []

 PUP = []
 PAU = []

 PLO = []
 PAL = []

 GLMT = []
 Glog_funr = []
 Glog_funi = []
 GALMR = []
 GALMI = []

 
 slog_fun=[]
 if denom(log_fun) <> 1 then
//   fe1 = factors(numer(log_fun))
//   for i=1:size(fe1)
//     if degree(fe1(i))==2 then
//       slog_fun=[slog_fun,syslin(t0,fe1(i)/z^2)]
//     else
//       slog_fun=[slog_fun,syslin(t0,fe1(i)/z)]
//     end
 //  end
   a1 = roots(numer(log_fun)).'
   fe1 = ones(a1)-a1/z
 
   slog_fun = syslin(t0,fe1)
 else
    slog_fun =1
 end

 for i=1:size(fw,'*')
   if ufabs(i,1) >= fabs(i,1) then
     GUP = [GUP;log(ufabs(i,1))-real(horner(fa1,w0(i,1))+log(horner(log_fun,w0(i,1))))]
     GAU = [GAU;real(horner(fza,w0(i,1)))]
   end

   if lfabs(i,1) < fabs(i,1) then
     GLO = [GLO;log(lfabs(i,1))-real(horner(fa1,w0(i,1))+log(horner(log_fun,w0(i,1))))]
     GAL = [GAL;real(horner(fza,w0(i,1)))]
   end

   if ufarg(i,1) >= farg(i,1) then
     pp0 = imag(sum(log(horner(slog_fun,w0(i,1)))))
     PUP = [PUP;ufarg(i,1)-imag(horner(fa1,w0(i,1)))-pp0]
     PAU = [PAU;imag(horner(fza,w0(i,1)))]

   end

   if lfarg(i,1) < farg(i,1) then
     pp0 = imag(sum(log(horner(slog_fun,w0(i,1)))))
     PLO = [PLO;lfarg(i,1)-imag(horner(fa1,w0(i,1)))-pp0]
     PAL = [PAL;imag(horner(fza,w0(i,1)))]
   end

   if dplmt(i,1) <> 0 then
     GLMT = [GLMT;dplmt(i,1)]
     Glog_funr = [Glog_funr;real(horner(fa1,w0(i,1))+log(horner(log_fun,w0(i,1))))]
     pp0 = imag(sum(log(horner(slog_fun,w0(i,1)))))
     Glog_funi = [Glog_funi;imag(horner(fa1,w0(i,1)))+pp0]
     GALMR = [GALMR;real(horner(fza,w0(i,1)))]
     GALMI = [GALMI;imag(horner(fza,w0(i,1)))]
   end

 end

 tlist('PXL','LMT','log_r','log_i','GAR','GAI')
 PXL.LMT = GLMT
 PXL.log_r = Glog_funr
 PXL.log_i = Glog_funi
 PXL.GAR   = GALMR
 PXL.GAI   = GALMI 


// set equation 
//
//  if c_flag(1,1) == 0 then
//
//     EP*A0 = EK
//
 pa = r_poles(:,1)
 ka = r_poles(:,2)

 EP = []
 EK = []
 if c_flag(1,2) <> 2 then
   for i = 1:size(pa,'*')
     EP = [EP;real(horner(fza,pa(i,1)))]
     EK = [EK;real(ka(i,1)-horner(fa1,pa(i,1))-log(horner(log_fun,pa(i,1))))]
     if imag(pa(i,1)) <> 0 then
       EP = [EP;imag(horner(fza,pa(i,1)))]
       pp0 = sum(log(horner(slog_fun,pa(i,1))))
       EK = [EK;imag(ka(i,1)-horner(fa1,pa(i,1))-pp0)]
     end
   end
 end

 tlist('EX','GE1','E1')

 EX.GE1 = EP
 EX.E1 = EK

//  set limit at l_poles

//  au > dr1*real(fa1 + fp1*(a0+ a1/z+..) ) > al
//  pu > dr1*imag(fa1 + fp1*(a0+ a1/z+..) ) > pl
//

 pol =  l_poles(:,1)
 au =  l_poles(:,2) 
 al =  l_poles(:,3)
 pu =  l_poles(:,4)
 pl =  l_poles(:,5)
 dr1 = l_poles(:,6)
 lfun = l_poles(:,7)

 BUl = []
 GBUl = []

 BLl = []
 GBLl = []

 PUl = []
 GPUl = []

 PLl = []
 GPLl = []
 

 for i= 1: size(pol,'*')
   fzas = fza*dr1(i,1)
   fa1s = fa1*dr1(i,1)
   
   log_off = 1
   slog_fun0 = 1
   if lfun(i,1) <> 0 then
     log_off = log_fun  //  assume limit for S, if limit for X set 1
     slog_fun0 = slog_fun
   end

   if au(i,1) <> 0 then
      GBUl = [GBUl;real(horner(fzas,pol(i,1)))]    
      BUl = [BUl;log(au(i,1))-real(horner(fa1s,pol(i,1))+dr1(i,1)*log(horner(log_off,pol(i,1))))]

   end

   if al(i,1) <> 0 then
      GBLl = [GBLl;real(horner(fzas,pol(i,1)))]   
      BLl = [BLl;log(al(i,1))-real(horner(fa1s,pol(i,1))+dr1(i,1)*log(horner(log_off,pol(i,1))))]
     
   end

   if pu(i,1) <> 0 then
    
      pp0 = imag(sum(log(horner(slog_fun0,pol(i,1)))))*dr1(i,1)     
      GPUl = [GPUl;imag(horner(fzas,pol(i,1)))]
      PUl = [PUl;pu(i,1)-imag(horner(fa1s,pol(i,1)))-pp0]
   end

   if pl(i,1) <> 0 then
   
      pp0 = imag(sum(log(horner(slog_fun0,pol(i,1)))))*dr1(i,1)
      GPLl = [GPLl;imag(horner(fzas,pol(i,1)))]
      PLl = [PLl;pl(i,1)-imag(horner(fa1s,pol(i,1)))-pp0]
   end
 end

 tlist('BLU','G1','GA1','G2','GA2','P1','PA1','P2','PA2')

 BLU.G1  = BUl 
 BLU.GA1 = GBUl
 BLU.G2  = BLl 
 BLU.GA2 = GBLl

 BLU.P1  = PUl 
 BLU.PA1 = GPUl
 BLU.P2  = PLl 
 BLU.PA2 = GPLl

//  smooth function 
//  F = fa1 + fp1*(c0*z^(-starti) + c1*z^(-starti-1) + ..
//  E = log ( log_fun ) + F

 ns = 100
 dw = 0.05

 ws0 = 0.001*1/t0/2
 wsn = 0.999*1/t0/2/(1+dw)
 wsn = 1/t0/2

 wn = (wsn-ws0)*(0: ns )/ns + ws0
 wn0= 2*%pi*t0*wn
 z0 = exp(%i*wn0')
 z1 = exp(%i*wn0'*(1+dw))
 
 w_weight = get_xerr(fweight,wn)

 SM0 = []
 SMF = []

 if (c_flag(1,2) == 0) | ( c_flag(1,2)==2) then
   tf1 = fderiv(fza)*%i*z
   dga1 = fderiv(fa1)*%i*z

//  F1 - F0   
   iw = inv(diag(wn0*dw))
   cwx = iw*(horner(fa1,z1)-horner(fa1,z0)) - horner(dga1,z0)
   dwx = iw*(horner(fza,z1)-horner(fza,z0)) - horner(tf1,z0)
// take real only
   SM0 = real(cwx)
   SMF = real(dwx)   //  E(i,1) = SM0(i,1) + SMF(i,:)*C0
 end

//
 global logfir_1

 logfir_1 = list( GUP, GAU, GLO, GAL, PUP, PAU, PLO, PAL,c_flag,SM0,SMF,EX,BLU,w_weight,PXL)

 Mbound = 1e3
 abstol = 1e-13
 nu = 1
 maxiters = 1000
 reltol = 1e-10

 options = [Mbound,abstol,nu,maxiters,reltol]

 A0 = ones(forder+1,1)
 lamda = 1
 A0l = list(A0, lamda) 
 fans = lmisolver(A0l,logfir2,options)
 fx = syslin(t0,fa1+fza*fans(1))


 v2 = exp(repfreq(fx,fw)).*horner(log_fun,exp(%i*2*%pi*t0*fw'))

 q0 = ufarg < farg
 ufarg= ufarg.*(~q0) + (%pi*0.999)*q0
 fu1 = ufabs.*exp(%i*ufarg)
 
 q1 = lfabs >= fabs
 lfabs  = lfabs.*(~q1)+min([abs(v2(1,1)),min(lfabs)]).*q1
 
 q2 = lfarg >= farg
 lfarg = lfarg.*(~q2)+(-%pi*0.999*q2)
 fl1 = lfabs.*exp(%i*lfarg)

 clf()
 //bode(fw',[fu1.';fl1.';v2],['upper';'lower';'Answer'])
bode(fw',[fu1.';fl1.';v2],['Answer';'lower';'upper'])

 fws0 = 0.001*1/t0/2
 fwsn = 0.999*1/t0/2

 fns = 300
 fwn = (fwsn-fws0)*(0: fns )/fns + fws0
 
 fo=mopen('apgain.txt','w')
 

 frr = exp(repfreq(fx,fwn)).*horner(log_fun,exp(%i*2*%pi*t0*fwn))

 for i=1:size(frr,'*')
   mfprintf(fo,"%e %e %e\n",fwn(1,i),abs(frr(1,i)),imag(log(frr(1,i)))/%pi*180)
 end
 mclose(fo)
 
 disp('apgain.txt is created')
 aa = fx
endfunction

